# coding: utf-8

"""
    Snowflake Services API

    The Snowflake Services API is a REST API that you can use to access, update, and perform certain actions on Services resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json
import snowflake.core.service._generated.models
from snowflake.core.service._generated.models import *


from typing import Optional, Union
from typing import Union
from pydantic import BaseModel, StrictStr

class ServiceSpecification(BaseModel):
    spec_type: Optional[StrictStr] = None
    __properties = ["spec_type"]


    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    # JSON field name that stores the object type
    __discriminator_property_name = 'spec_type'

    # discriminator mappings
    __discriminator_value_class_map = {
        'from_file': 'ServiceSpecStageFile',
        'from_inline': 'ServiceSpecInlineText'
    }

    @classmethod
    def get_discriminator_value(cls, obj: dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None


    __discriminator_value_to_type = {
        'ServiceSpecStageFile': 'from_file',
        'ServiceSpecInlineText': 'from_inline',
    }

    @classmethod
    def get_child_model_discriminator_value(cls, child_model: str) -> str:
        return cls.__discriminator_value_to_type[child_model]


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[ServiceSpecInlineText, ServiceSpecStageFile]:
        """Create an instance of ServiceSpecification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Union[ServiceSpecInlineText, ServiceSpecStageFile]:
        """Create an instance of ServiceSpecification from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = getattr(snowflake.core.service._generated.models, object_type)
            return klass.from_dict(obj)
        else:
            raise ValueError("ServiceSpecification failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


from typing import Optional, List, Dict

class ServiceSpecificationModel():
    def __init__(
        self,
        # optional properties
        spec_type: Optional[str] = None,
    ):
        self.spec_type = spec_type
    __properties = ["spec_type"]

    def _to_model(self):
        return ServiceSpecification(
            
        )

    @classmethod
    def _from_model(cls, model) -> ServiceSpecificationModel:
        return model.__class__._model_class._from_model(model)

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> Union(ServiceSpecInlineTextModel, ServiceSpecStageFileModel):
        """Create an instance of ServiceSpecification from a dict"""
        return cls._from_model(ServiceSpecification.from_dict(obj))


ServiceSpecification._model_class = ServiceSpecificationModel
