# coding: utf-8

"""
    Snowflake Table API

    The Snowflake Table API is a REST API that you can use to access, update, and perform certain actions on Tables resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class ListTablesShowLimitParameter(BaseModel):
    rows: StrictInt = ...
    name_string: Optional[StrictStr] = Field(None, alias="nameString")
    __properties = ["rows", "nameString"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListTablesShowLimitParameter:
        """Create an instance of ListTablesShowLimitParameter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListTablesShowLimitParameter:
        """Create an instance of ListTablesShowLimitParameter from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ListTablesShowLimitParameter.parse_obj(obj)

        _obj = ListTablesShowLimitParameter.parse_obj({
            "rows": obj.get("rows"),
            "name_string": obj.get("nameString")
        })
        return _obj


from typing import Optional, List, Dict

class ListTablesShowLimitParameterExternal():
    def __init__(
        self,
        rows: int,
        name_string: Optional[str] = None,
    ):
        self.rows = rows
        self.name_string = name_string
    __properties = ["rows", "nameString"]

    def _to_model(self):
        return ListTablesShowLimitParameter(
            rows=self.rows,
            name_string=self.name_string,
        )

    @classmethod
    def _from_model(cls, model) -> ListTablesShowLimitParameterExternal:
        return ListTablesShowLimitParameterExternal(
            rows=model.rows,
            name_string=model.name_string,
        )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> ListTablesShowLimitParameterExternal:
        """Create an instance of ListTablesShowLimitParameter from a dict"""
        return cls._from_model(ListTablesShowLimitParameter.from_dict(obj))

