# coding: utf-8

"""
    Snowflake Table API

    The Snowflake Table API is a REST API that you can use to access, update, and perform certain actions on Tables resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictInt, StrictStr

class TableObjectParameters(BaseModel):
    data_rentention_time_in_days: Optional[StrictInt] = None
    max_data_extension_time_in_days: Optional[StrictInt] = None
    default_ddl_collation: Optional[StrictStr] = None
    __properties = ["data_rentention_time_in_days", "max_data_extension_time_in_days", "default_ddl_collation"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TableObjectParameters:
        """Create an instance of TableObjectParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TableObjectParameters:
        """Create an instance of TableObjectParameters from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TableObjectParameters.parse_obj(obj)

        _obj = TableObjectParameters.parse_obj({
            "data_rentention_time_in_days": obj.get("data_rentention_time_in_days"),
            "max_data_extension_time_in_days": obj.get("max_data_extension_time_in_days"),
            "default_ddl_collation": obj.get("default_ddl_collation")
        })
        return _obj


from typing import Optional, List, Dict

class TableObjectParametersModel():
    def __init__(
        self,
        # optional properties
        data_rentention_time_in_days: Optional[int] = None,
        max_data_extension_time_in_days: Optional[int] = None,
        default_ddl_collation: Optional[str] = None,
    ):
        self.data_rentention_time_in_days = data_rentention_time_in_days
        self.max_data_extension_time_in_days = max_data_extension_time_in_days
        self.default_ddl_collation = default_ddl_collation
    __properties = ["data_rentention_time_in_days", "max_data_extension_time_in_days", "default_ddl_collation"]

    def _to_model(self):
        return TableObjectParameters(
            data_rentention_time_in_days=self.data_rentention_time_in_days,
            max_data_extension_time_in_days=self.max_data_extension_time_in_days,
            default_ddl_collation=self.default_ddl_collation,
        )

    @classmethod
    def _from_model(cls, model) -> TableObjectParametersModel:
        return TableObjectParametersModel(
            data_rentention_time_in_days=model.data_rentention_time_in_days,
            max_data_extension_time_in_days=model.max_data_extension_time_in_days,
            default_ddl_collation=model.default_ddl_collation,
        )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> TableObjectParametersModel:
        """Create an instance of TableObjectParameters from a dict"""
        return cls._from_model(TableObjectParameters.from_dict(obj))

